﻿namespace GridCloneDisplayLayout
{
    using System.Diagnostics;
    using System.Windows.Forms;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinDataSource;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private readonly BindableValueList ValueList = new BindableValueList();
        private readonly UltraGrid Grid;

        public Form1()
        {
            InitializeComponent();

            ValueList.ValueListItems.Add(1, "First");
            ValueList.ValueListItems.Add(2, "Second");


            Grid = new UltraGrid { Dock = DockStyle.Fill };
            Grid.InitializeLayout += Grid_InitializeLayout;
            Controls.Add(Grid);

            Grid.DataSource = CreateDataSource(1);

            // Uncomment line below to get the problem
            ResetDataSource();
        }

        private static UltraDataSource CreateDataSource(int number)
        {
            var ds = new UltraDataSource();
            ds.Band.Columns.Add("Number", typeof(int));
            ds.Rows.Add(new object[] { number });
            return ds;
        }

        private void ResetDataSource()
        {
            var layout = Grid.DisplayLayout.Clone();

            Debug.WriteLine(Grid.DisplayLayout.Bands[0].Columns["Number"].ValueList.ItemCount);
            Debug.WriteLine(layout.Bands[0].Columns["Number"].ValueList.ItemCount);

            Grid.DataSource = CreateDataSource(2);
            Grid.DisplayLayout.CopyFrom(layout);
        }

        private void Grid_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var column = Grid.DisplayLayout.Bands[0].Columns["Number"];
            if (e.Layout.ValueLists.Contains(ValueList) == false)
            {
                e.Layout.ValueLists.Add(ValueList);
            }

            column.ValueList = e.Layout.ValueLists[0];
            column.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownList;
        }
    }
}
